package auth

import (
	"encoding/base64"
	"net/http"
	"net/url"
	"time"

	_ "github.com/paulrosania/go-charset/data"

	"git.icedream.tech/icedream/oneandone-billing-mailer/pkg/appcontext"
	"git.icedream.tech/icedream/oneandone-billing-mailer/pkg/environment"
)

const (
	client_id          = "access.mobile.app"
	client_secret_live = "Yi79C2YG2CJYH!U9TXPRpXRciyhApr"
	redirect_url       = "com.oneandone.controlcenter.android://oauth"
)

var urlEncodingWithoutPadding = base64.URLEncoding.WithPadding(base64.NoPadding)

type CentralLoginHelper struct {
	baseUri *url.URL
}

func NewCentralLoginHelper() (*CentralLoginHelper, error) {
	ctx, err := appcontext.GetEnvironmentContext()
	if err != nil {
		return nil, err
	}
	baseURL, err := ctx.CentralLogin.BaseURL()
	if err != nil {
		return nil, err
	}
	return &CentralLoginHelper{
		baseUri: baseURL,
	}, nil
}

func clientSecretForEnvironment() string {
	return client_secret_live
}
